/* mnb6d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int mnb6d_c(integer *n, integer *np1, integer *itmax,
        doublereal *alfa, doublereal *beta, doublereal *gam, doublereal *acc, 
        doublereal *a, doublereal *x, doublereal *xcen, doublereal *z__, 
        doublereal *xref, doublereal *xcon, doublereal *xex, doublereal *xx, 
        doublereal *ff, integer *maxk, S_fp fun, integer *ierr)
{
    /* Initialized data */

    static doublereal c__ = 1e-4;

    /* System generated locals */
    integer x_dim1, x_offset, i__1, i__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static doublereal zcen, zref, zcon;
    static integer i__, j, k, l;
    static doublereal p, q;
    static integer kount;
    static doublereal fe, en, eps, zhi;
    static integer itr;
    static doublereal sum, zex;

#define x_ref(a_1,a_2) x[(a_2)*x_dim1 + a_1]

/*   POPAMMA EYCOBHO MHMA METOOM HEEPA-MA. */
/*     APAMETP */
/*     N     -PAMEPHOCT POCTPAHCTBA EPEMEHHX */
/*     NP1   -PAMEPHOCT MHOOPAHHKA */
/*     ITMAX -MAKCMAHOE CO TEPA */
/*     ALFA  -APAMETP OTPAEH */
/*     BETA  -APAMETP CAT */
/*     GAM   -APAMETP PACTEH */
/*     ACC   -TOHOCT BCEH */
/*     A     -PAMEP CXOHOO MHOOPAHHKA */
/*     X,XCEN,Z,XREF,XCON,XEX-PAOE MACCB */
/*     XX    -HA BXOE-HAAHA TOKA OCKA, */
/*            HA BXOE-TOKA MHMYMA */
/*     FF    -MHMAHOE HAEHE YHK */
/*     MAXK  -MAKCMAHOE CO BC. YHK */
/*     FUN   -OPOPAMMA BCEH YHK */
/*     IERR  -PHAK OKOHAH OCKA */
    /* Parameter adjustments */
    --xx;
    --xex;
    --xcon;
    --xref;
    --xcen;
    --z__;
    x_dim1 = *np1;
    x_offset = 1 + x_dim1 * 1;
    x -= x_offset;

    /* Function Body */
    l = 0;
    itr = 0;
    kount = 0;
    q = *a / (*n * sqrt(2.)) * (sqrt(*n + 1.) - 1.);
    p = *a / (*n * sqrt(2.)) * (sqrt(*n + 1.) + *n - 1.);
/*  OCTPOEHE HAAHOO CMEKCA */
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
/* L100: */
        x_ref(1, j) = xx[j];
    }
    i__1 = *np1;
    for (i__ = 2; i__ <= i__1; ++i__) {
        i__2 = *n;
        for (j = 1; j <= i__2; ++j) {
            x_ref(i__, j) = x_ref(1, j) + q;
            if (i__ - 1 == j) {
                x_ref(i__, j) = x_ref(1, j) + p;
            }
/* L120: */
        }
    }
    if (*alfa == 0.) {
        *alfa = 1.;
    }
    if (*beta == 0.) {
        *beta = .5;
    }
    if (*gam == 0.) {
        *gam = 2.;
    }
    if (*acc == 0.) {
        *acc = c__;
    }
/*  HAAO TEPA */
L150:
    i__2 = *np1;
    for (i__ = 1; i__ <= i__2; ++i__) {
        if (i__ == l) {
            goto L155;
        }
        i__1 = *n;
        for (j = 1; j <= i__1; ++j) {
/* L154: */
            xx[j] = x_ref(i__, j);
        }
        (*fun)(&xx[1], &z__[i__], &fe);
        ++kount;
L155:
        ;
    }
L162:
    ++itr;
    if (itr > *itmax) {
        goto L270;
    }
    if (kount > *maxk) {
        goto L280;
    }
    zhi = z__[1];
    *ff = z__[1];
    k = 1;
    l = 1;
    i__2 = *np1;
    for (i__ = 2; i__ <= i__2; ++i__) {
        if (zhi >= z__[i__]) {
            goto L164;
        }
        zhi = z__[i__];
        k = i__;
L164:
        if (*ff <= z__[i__]) {
            goto L165;
        }
        *ff = z__[i__];
        l = i__;
L165:
        ;
    }
/*  EHTPO */
    en = (doublereal) (*n);
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
        sum = 0.;
        i__1 = *np1;
        for (i__ = 1; i__ <= i__1; ++i__) {
            if (k == i__) {
                goto L175;
            }
            sum += x_ref(i__, j);
L175:
            ;
        }
/* L180: */
        xcen[j] = sum / en;
    }
    (*fun)(&xcen[1], &zcen, &fe);
    ++kount;
    sum = 0.;
    i__2 = *np1;
    for (i__ = 1; i__ <= i__2; ++i__) {
        if (k == i__) {
            goto L185;
        }
        sum += (z__[i__] - zcen) * (z__[i__] - zcen) / en;
L185:
        ;
    }
    eps = sqrt(sum);
    if (eps < *acc) {
        goto L261;
    }
/*  OTPAEHE */
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
/* L190: */
        xref[j] = xcen[j] + *alfa * (xcen[j] - x_ref(k, j));
    }
    (*fun)(&xref[1], &zref, &fe);
    ++kount;
    if (zref <= z__[l]) {
        goto L240;
    }
    i__2 = *np1;
    for (i__ = 1; i__ <= i__2; ++i__) {
        if (zref < z__[i__] && i__ != k) {
            goto L208;
        }
/* L200: */
    }
    goto L215;
L208:
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
/* L210: */
        x_ref(k, j) = xref[j];
    }
    z__[k] = zref;
    goto L162;
/*  CATE */
L215:
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
/* L220: */
        xcon[j] = xcen[j] + *beta * (x_ref(k, j) - xcen[j]);
    }
    (*fun)(&xcon[1], &zcon, &fe);
    ++kount;
    if (zcon >= z__[k]) {
        goto L224;
    }
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
/* L222: */
        x_ref(k, j) = xcon[j];
    }
    z__[k] = zcon;
    goto L162;
/*  PEYK */
L224:
    i__2 = *n;
    for (j = 1; j <= i__2; ++j) {
        i__1 = *np1;
        for (i__ = 1; i__ <= i__1; ++i__) {
/* L225: */
            x_ref(i__, j) = (x_ref(i__, j) + x_ref(l, j)) / 2.;
        }
    }
    goto L150;
/*  PACTEHE */
L240:
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
/* L245: */
        xex[j] = xcen[j] + *gam * (xref[j] - xcen[j]);
    }
    (*fun)(&xex[1], &zex, &fe);
    ++kount;
    if (zex < z__[l]) {
        goto L255;
    }
    goto L208;
L255:
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
/* L260: */
        x_ref(k, j) = xex[j];
    }
    z__[k] = zex;
    goto L162;
/*  B  X O  */
L261:
    *ierr = 1;
    goto L300;
L270:
    *ierr = 65;
    --itr;
    goto L300;
L280:
    *ierr = 66;
L300:
    i__1 = *n;
    for (j = 1; j <= i__1; ++j) {
/* L310: */
        xx[j] = x_ref(l, j);
    }
    *maxk = kount;
    *itmax = itr;
/* L1000: */
    return 0;
} /* mnb6d_c */

#undef x_ref
